
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class TCTestCaseBuilder extends Frame
{
	public TCTestCaseBuilder()
	{
	

		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(insets().left + insets().right + 1014,insets().top + insets().bottom + 526);
		newFileDialog1 = new java.awt.FileDialog(this);
		newFileDialog1.setMode(FileDialog.SAVE);
		newFileDialog1.setTitle("Save As");
		//$$ newFileDialog1.move(72,276);
		openFileDialog2 = new java.awt.FileDialog(this);
		openFileDialog2.setMode(FileDialog.LOAD);
		openFileDialog2.setTitle("Open");
		//$$ openFileDialog2.move(40,277);
		buttonPrevious = new java.awt.Button();
		buttonPrevious.setLabel("Previous Test Case");
		buttonPrevious.setBounds(insets().left + 36,insets().top + 240,120,31);
		buttonPrevious.setBackground(java.awt.Color.lightGray);
		add(buttonPrevious);
		buttonPrevious.setEnabled(false);
		fileNameLabel = new java.awt.Label("Select New or Open from Menu");
		fileNameLabel.setBounds(insets().left + 12,insets().top + 12,180,31);
		fileNameLabel.setForeground(java.awt.Color.green);
		add(fileNameLabel);
		tempInput = new java.awt.TextField();
		tempInput.setBounds(insets().left + 192,insets().top + 72,108,34);
		add(tempInput);
		tempInput.setEnabled(false);
		resultF = new java.awt.TextField();
		resultF.setBounds(insets().left + 396,insets().top + 84,87,28);
		add(resultF);
		resultF.setEnabled(false);
		resultC = new java.awt.TextField();
		resultC.setBounds(insets().left + 396,insets().top + 132,87,28);
		add(resultC);
		resultC.setEnabled(false);
		resultK = new java.awt.TextField();
		resultK.setBounds(insets().left + 396,insets().top + 180,87,28);
		add(resultK);
		resultK.setEnabled(false);
		labelF = new java.awt.Label("F");
		labelF.setBounds(insets().left + 360,insets().top + 84,22,23);
		add(labelF);
		labelC = new java.awt.Label("C");
		labelC.setBounds(insets().left + 360,insets().top + 132,22,23);
		add(labelC);
		labelK = new java.awt.Label("K");
		labelK.setBounds(insets().left + 360,insets().top + 180,22,23);
		add(labelK);
		tempInputLabel = new java.awt.Label("Input");
		tempInputLabel.setBounds(insets().left + 192,insets().top + 48,60,24);
		add(tempInputLabel);
		buttonNext = new java.awt.Button();
		buttonNext.setLabel("Next Test Case");
		buttonNext.setBounds(insets().left + 180,insets().top + 240,96,31);
		buttonNext.setBackground(java.awt.Color.lightGray);
		add(buttonNext);
		labelOutput = new java.awt.Label("Outputs");
		labelOutput.setBounds(insets().left + 396,insets().top + 60,101,16);
		add(labelOutput);
		SaveNeed = new java.awt.Label("Needs to be Saved");
		SaveNeed.setVisible(false);
		SaveNeed.setBounds(insets().left + 12,insets().top + 36,144,27);
		SaveNeed.setForeground(java.awt.Color.magenta);
		add(SaveNeed);
		buttonAdd = new java.awt.Button();
		buttonAdd.setLabel("Add New Test Case");
		buttonAdd.setBounds(insets().left + 300,insets().top + 240,115,28);
		buttonAdd.setBackground(java.awt.Color.lightGray);
		add(buttonAdd);
		buttonAdd.setEnabled(false);
		buttonStore = new java.awt.Button();
		buttonStore.setLabel("Store Test Case");
		buttonStore.setBounds(insets().left + 504,insets().top + 108,115,28);
		buttonStore.setBackground(java.awt.Color.lightGray);
		add(buttonStore);
		buttonStore.setEnabled(false);
		Group1 = new CheckboxGroup();
		radioButtonF = new java.awt.Checkbox("F", Group1, false);
		radioButtonF.setBounds(insets().left + 192,insets().top + 132,60,10);
		add(radioButtonF);
		radioButtonC = new java.awt.Checkbox("C", Group1, false);
		radioButtonC.setBounds(insets().left + 192,insets().top + 156,60,10);
		add(radioButtonC);
		radioButtonK = new java.awt.Checkbox("K", Group1, false);
		radioButtonK.setBounds(insets().left + 192,insets().top + 180,60,10);
		add(radioButtonK);
		buttonDelete = new java.awt.Button();
		buttonDelete.setLabel("Delete Test Case");
		buttonDelete.setBounds(insets().left + 564,insets().top + 240,115,28);
		buttonDelete.setBackground(java.awt.Color.lightGray);
		add(buttonDelete);
		buttonDelete.setEnabled(false);
		buttonChange = new java.awt.Button();
		buttonChange.setLabel("Change Test Case");
		buttonChange.setBounds(insets().left + 432,insets().top + 240,115,28);
		buttonChange.setBackground(java.awt.Color.lightGray);
		add(buttonChange);
		buttonChange.setEnabled(false);
		buttonCancel = new java.awt.Button();
		buttonCancel.setLabel("Cancel");
		buttonCancel.setBounds(insets().left + 504,insets().top + 156,115,28);
		buttonCancel.setBackground(java.awt.Color.lightGray);
		add(buttonCancel);
		buttonCancel.setEnabled(false);
		setTitle("Temperature Converter Test Input");
		//}}

		//{{INIT_MENUS
		mainMenuBar = new MenuBar();
		menu1 = new Menu("File");
		miNew = new MenuItem("New", new MenuShortcut(KeyEvent.VK_N));
		menu1.add(miNew);
		miOpen = new MenuItem("Open...",  new MenuShortcut(KeyEvent.VK_O));
		menu1.add(miOpen);
		miSave = new MenuItem("Save",  new MenuShortcut(KeyEvent.VK_S));
		menu1.add(miSave);
		miSaveAs = new MenuItem("Save As...");
		menu1.add(miSaveAs);
		menu1.addSeparator();
		miExit = new MenuItem("Exit", new MenuShortcut(KeyEvent.VK_Q));
		menu1.add(miExit);
		mainMenuBar.add(menu1);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.move(4,277);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		miOpen.addActionListener(lSymAction);
		miExit.addActionListener(lSymAction);
		miNew.addActionListener(lSymAction);
		miSave.addActionListener(lSymAction);

		
		miSaveAs.addActionListener(lSymAction);
		buttonAdd.addActionListener(lSymAction);
		buttonStore.addActionListener(lSymAction);
		buttonNext.addActionListener(lSymAction);
		buttonPrevious.addActionListener(lSymAction);
		
		buttonChange.addActionListener(lSymAction);
		buttonCancel.addActionListener(lSymAction);
		buttonDelete.addActionListener(lSymAction);
		
		createEmptyVector();
		fileOpen=false;
		fileDirty=false;
		viewing=true;
		setState();
		//}}
	
		//{{REGISTER_LISTENERS
		 lSymAction = new SymAction();
		miSaveAs.addActionListener(lSymAction);
		//}}
	}

	public TCTestCaseBuilder(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		move(50, 50);
		super.show();
	}

	static public void main(String args[])
	{
		(new TCTestCaseBuilder()).show();

	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	Vector v;
	String vdir;
	String vFileName;
	TestCaseFile theFile;
	boolean fileDirty;
    boolean viewing;
    boolean fileOpen;
	int currentTestCase;
	boolean adding;

	//{{DECLARE_CONTROLS
	java.awt.FileDialog newFileDialog1;
	java.awt.FileDialog openFileDialog2;
	java.awt.Button buttonPrevious;
	java.awt.Label fileNameLabel;
	java.awt.TextField tempInput;
	java.awt.TextField resultF;
	java.awt.TextField resultC;
	java.awt.TextField resultK;
	java.awt.Label labelF;
	java.awt.Label labelC;
	java.awt.Label labelK;
	java.awt.Label tempInputLabel;
	java.awt.Button buttonNext;
	java.awt.Label labelOutput;
	java.awt.Label SaveNeed;
	java.awt.Button buttonAdd;
	java.awt.Button buttonStore;
	java.awt.Checkbox radioButtonF;
	CheckboxGroup Group1;
	java.awt.Checkbox radioButtonC;
	java.awt.Checkbox radioButtonK;
	java.awt.Button buttonDelete;
	java.awt.Button buttonChange;
	java.awt.Button buttonCancel;
	//}}

	//{{DECLARE_MENUS
	MenuBar mainMenuBar;
	Menu menu1;
	MenuItem miNew;
	MenuItem miOpen;
	MenuItem miSave;
	MenuItem miSaveAs;
	MenuItem miExit;
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == TCTestCaseBuilder.this)
				Frame1_WindowClosing(event);
		}
	}

	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();	  // free the system resources
		System.exit(0); // close the application
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == miOpen)
				miOpen_Action(event);
			else if (object == miExit)
				miExit_Action(event);
			else if (object == miNew)
				miNew_Action(event);
			else if (object == miSave)
				miSave_Action(event);
			else if (object == miSaveAs)
				miSaveAs_Action(event);
			else if (object == buttonAdd)
				buttonAdd_Action(event);
			else if (object == buttonStore)
				buttonStore_Action(event);
			else if (object == buttonNext)
				buttonNext_Action(event);
			else if (object == buttonPrevious)
				buttonPrevious_Action(event);
			else if (object == buttonDelete)
				buttonDelete_Action(event);
			else if (object == buttonChange)
			    buttonChange_Action(event);
			else if (object== buttonCancel)
			    buttonCancel_Action(event);
			    
		}
	}


	void miExit_Action(java.awt.event.ActionEvent event)
	{
	    if (fileDirty) saveFile();
		//{{CONNECTION
		// Action from Exit Create and show as modal
		
		(new QuitDialog(this, true)).show();
		//}}
	}

	void miOpen_Action(java.awt.event.ActionEvent event)
	{
	    if (fileDirty)
	        saveFile(); 
		
		openFileDialog2.show();
		vFileName=openFileDialog2.getFile();
		vdir=openFileDialog2.getDirectory();

        try {
            theFile = new TestCaseFile(vdir, vFileName);
            v=theFile.getTheVector();
            fileOpen=true;
            fileDirty=false;
            viewing=true;
                if (v.isEmpty()) {
                    tempInput.setText("");
                    resultF.setText("");
                    resultC.setText("");
                    resultK.setText("");

                } else {
                    try {
                        currentTestCase=v.indexOf(v.firstElement());
                        displayTestCase();
                    } catch (NoSuchElementException oops) {
                        System.out.println(oops);
                    }
                }
           setState();
        } catch (Exception oops) {
                System.out.println(oops);

        }
    }

	void miNew_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		if (fileDirty) {
		    saveFile();
		}


		//{{CONNECTION
		// Show the SaveFileDialog
		newFileDialog1.show();
		// create a new vector file and store it
		vFileName=newFileDialog1.getFile();
		vdir=newFileDialog1.getDirectory();
	    this.createEmptyVector();
	    theFile=new TestCaseFile(vdir, vFileName);
		this.saveFile();
		fileOpen=true;
		fileDirty=false;
		viewing=true;
		setState();
	}

	void miSave_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		saveFile();
		fileOpen=true;
		fileDirty=false;
		viewing=true;
		setState();

	}
	  

		private void saveFile() {

            try {
                theFile.putTheVector(v);
                fileDirty=false; //not dirty anymore


            } catch (Exception oops) {
                    System.out.println(oops);
            };
        }
        private void displayTestCase() {
            try {
                TempConverterTestCase t=(TempConverterTestCase) v.elementAt(currentTestCase);
                tempInput.setText(t.inputTemperature);
                resultF.setText(t.FResult);
                resultC.setText(t.CResult);
                resultK.setText(t.KResult);

                if (t.temperatureScale.equals("F")) {
                    radioButtonF.setState(true);
                } else {
                    if (t.temperatureScale.equals("C")) {
                        radioButtonC.setState(true);
                    } else {
                        radioButtonK.setState(true);
                     }
                }
                
                 viewing=true;
                 setState();
            } catch (ArrayIndexOutOfBoundsException oops) {
                    System.out.println(oops);
            }
        }
        private void createEmptyVector() {
            v=new Vector();
        }



	void miSaveAs_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

			        newFileDialog1.show();
			        vFileName=newFileDialog1.getFile();
			        vdir=newFileDialog1.getDirectory();
			        theFile=new TestCaseFile(vdir, vFileName);
			        saveFile();
			        fileDirty=false;
			        fileOpen=true;
			        viewing=true;
			        setState();
	}

	void buttonAdd_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 viewing=false;
			 adding=true;
			 setState();
		//{{CONNECTION
		tempInput.setText("");

		resultF.setText("");
		resultC.setText("");
		resultK.setText("");
		//}}

	}

	void buttonStore_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		TempConverterTestCase aTestCase = new TempConverterTestCase();
		aTestCase.inputTemperature=tempInput.getText();

		        if (radioButtonF.getState()) {
		            aTestCase.temperatureScale="F";
		        } else {
		            if (radioButtonC.getState()) {
		            aTestCase.temperatureScale="C";
		            } else {
		            aTestCase.temperatureScale="K";
		            }
		        }
		aTestCase.FResult=resultF.getText();

		aTestCase.CResult=resultC.getText();

		aTestCase.KResult=resultK.getText();

        if (adding) {
	        v.addElement(aTestCase);
    	    currentTestCase=v.indexOf(aTestCase);
	    } else {
	        try {
    	        v.setElementAt(aTestCase, currentTestCase);
    	    } catch (Exception e) {}
    	}
	    displayTestCase();
	    fileDirty=true;
	    viewing=true;
	    setState();
    }


void buttonNext_Action(java.awt.event.ActionEvent event)
	{
	    currentTestCase++;
	    displayTestCase();
	    setState();
	    
	}

	void buttonPrevious_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		currentTestCase--;
		displayTestCase();
		setState();

	}
	void buttonChange_Action(java.awt.event.ActionEvent event) {
	    viewing=false;
	    adding=false;
	    setState();
	}
	void buttonCancel_Action(java.awt.event.ActionEvent event) {
	    viewing=true;
	    displayTestCase();
	    setState();
	}

	void buttonDelete_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		
		    try {
		        v.removeElementAt(currentTestCase);
		        // display the next entry if there
		        
		        if (v.size()==currentTestCase) {
		            // deleted the last entry
		                if (currentTestCase > 0) {
		                    //but there is at least one before it; display previous
		                    currentTestCase--;
		                    displayTestCase();
		                } else {
		                    //removed everything
		                    tempInput.setText("");
		                    resultF.setText("");

		                    resultC.setText("");

		                    resultK.setText("");
		                }
		        } else {
		            // display the next guy
		            displayTestCase();
		            
		        }
		        fileOpen=true;
		        fileDirty=true;
		        viewing=true;
		        setState();
		    }catch (Exception e) {
		    }
	}
		
	void setState(){
	    // menu state
	    if (fileOpen) {
	       
	            miNew.setEnabled(viewing);
	            miOpen.setEnabled(viewing);
	            miSave.setEnabled(fileDirty);
	            miSaveAs.setEnabled(viewing);
	            miExit.setEnabled(viewing);
	                
	        
	        
	    } else {
	        
	            miNew.setEnabled(true);
	            miOpen.setEnabled(true);
	            miSave.setEnabled(false);
	            miSaveAs.setEnabled(false);
	            miExit.setEnabled(true);
	    }
	        // Buttons
	        if (fileOpen) {
	                buttonAdd.setEnabled(viewing);
	                buttonChange.setEnabled(viewing);
	                buttonDelete.setEnabled(viewing);
	                buttonNext.setEnabled(viewing);
	                buttonPrevious.setEnabled(viewing);
	                buttonStore.setEnabled(!viewing);
	                buttonCancel.setEnabled(!viewing);
	              if (viewing) {
	                // adjust for file contents
	                buttonChange.setEnabled(!v.isEmpty());
	                buttonDelete.setEnabled(!v.isEmpty());
	                buttonNext.setEnabled(v.size() > currentTestCase + 1);
	                buttonPrevious.setEnabled(currentTestCase != 0);
	              }
	        } else {
	                buttonAdd.setEnabled(false);
	                buttonChange.setEnabled(false);
	                buttonDelete.setEnabled(false);
	                buttonNext.setEnabled(false);
	                buttonPrevious.setEnabled(false);
	                buttonStore.setEnabled(false);
	                buttonCancel.setEnabled(false);
        }
	        // Text Fields
	        if (fileOpen) {
	            
	            tempInput.setEnabled(true);
                resultF.setEnabled(true);
                resultC.setEnabled(true);
                resultK.setEnabled(true);
	            tempInput.setEditable(!viewing);
                resultF.setEditable(!viewing);
                resultC.setEditable(!viewing);
                resultK.setEditable(!viewing);
            } else {
	            tempInput.setEnabled(false);
                resultF.setEnabled(false);
                resultC.setEnabled(false);
                resultK.setEnabled(false);
	            tempInput.setEditable(false);
                resultF.setEditable(false);
                resultC.setEditable(false);
                resultK.setEditable(false);
            }
            // Radio Buttons
            if (fileOpen) {
                radioButtonF.setEnabled(!viewing);
                radioButtonC.setEnabled(!viewing);
                radioButtonK.setEnabled(!viewing);
            } else {
                
                radioButtonF.setEnabled(false);
                radioButtonC.setEnabled(false);
                radioButtonK.setEnabled(false);
            }
            // Labels
            if (fileOpen) {
                fileNameLabel.setText(vFileName);
                SaveNeed.setVisible(fileDirty);
            } else {
                fileNameLabel.setText("Select New or Open from Menu");
                SaveNeed.setVisible(false);
            }
    }
                
                
                
    
}


